
/* Tabela de HASH com CHAINING */


#define HASHSIZE    31


typedef char KeyType[9];
typedef void *Info;


typedef struct entry {
  KeyType  key;
  Info info;
  struct entry *next;
} Entry;


typedef Entry *HashTable[HASHSIZE];



// funo de hash  
int Hash(KeyType);

// inicializa a tabela de hash
void InitializeTable(HashTable);

// limpa a tabela de hash
void ClearTable(HashTable);

// insere uma nova associao entre uma chave nova e a restante informao
void InsertTable(HashTable, KeyType, Info);

// apaga o elemento de chave k da tabela
void DeleteTable(HashTable, KeyType);

// procura na tabela o elemento de chave k, e retorna o apontador 
// para a clula aonde a chave se encontra (ou NULL caso k no exista) 
Entry *RetriveTable(HashTable, KeyType);

